package de.meinefirma.meinprojekt.dao;

import java.util.List;
import org.junit.*;
import de.meinefirma.meinprojekt.entities.*;

public class PersonTeamDaoTest
{
   @Test
   public void testPersonTeamDao()
   {
      // Konstruiere das zu testende DAO:
      PersonTeamDao dao = new PersonTeamDao( null, null );

      // Loesche eventuell vorhandene Eintraege:
      dao.deleteAllEntities( Person.class );
      dao.deleteAllEntities( Team.class );

      // Teste createEntity() und queryEntities():
      Person p1 = new Person();
      Team   t1 = new Team();
      p1.setName( "p1" );
      t1.setName( "t1" );
      dao.createEntity( p1 );
      dao.createEntity( t1 );
      List<Person> p1Lst = dao.queryEntities( Person.QUERY_BY_NAME, "pname", "p1" );
      List<Team>   t1Lst = dao.queryEntities(   Team.QUERY_BY_NAME, "tname", "t1" );
      Assert.assertEquals(    1, p1Lst.size() );
      Assert.assertEquals(    1, t1Lst.size() );
      Assert.assertEquals( "p1", p1Lst.get( 0 ).getName() );
      Assert.assertEquals( "t1", t1Lst.get( 0 ).getName() );

      // Teste addDelPersonTeam() mit "add" (Zuordnung hinzufuegen):
      List<Person> pAll = dao.readAllEntities( Person.class );
      List<Team>   tAll = dao.readAllEntities( Team.class );
      dao.addDelPersonTeam( "add", null, "p1", "t1", pAll, tAll );
      pAll = dao.readAllEntities( Person.class );
      tAll = dao.readAllEntities( Team.class );
      Person p = pAll.get( 0 );
      Team   t = tAll.get( 0 );
      Assert.assertEquals( "t1", p.getTeam().getName() );
      Assert.assertTrue( t.getPersonen().contains( p ) );

      // Teste addDelPersonTeam() mit "del" (Zuordnung entfernen):
      dao.addDelPersonTeam( null, "del", "p1", "t1", pAll, tAll );
      pAll = dao.readAllEntities( Person.class );
      tAll = dao.readAllEntities( Team.class );
      p = pAll.get( 0 );
      t = tAll.get( 0 );
      Assert.assertNull( p.getTeam() );
      Assert.assertTrue( t.getPersonen().isEmpty() );
   }
}
